All of lore.kernel.org
 help / color / mirror / Atom feed
From: Xiong Zhou <xzhou@redhat.com>
To: fstests@vger.kernel.org
Cc: ross.zwisler@linux.intel.com, dan.j.williams@intel.com,
	jmoyer@redhat.com, eguan@redhat.com,
	Xiong Zhou <xzhou@redhat.com>
Subject: [PATCH v3 4/4] generic: mmap write readonly DAX file
Date: Wed, 12 Apr 2017 22:46:20 +0800	[thread overview]
Message-ID: <1492008380-29164-5-git-send-email-xzhou@redhat.com> (raw)
In-Reply-To: <1492008380-29164-1-git-send-email-xzhou@redhat.com>

Regression case that one can write to read-only
file in a DAX mountpoint.

Signed-off-by: Xiong Zhou <xzhou@redhat.com>
---
 .gitignore            |  1 +
 src/Makefile          |  2 +-
 src/t_mmap_write_ro.c | 76 ++++++++++++++++++++++++++++++++++++++++++
 tests/generic/424     | 92 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/424.out |  2 ++
 tests/generic/group   |  1 +
 6 files changed, 173 insertions(+), 1 deletion(-)
 create mode 100644 src/t_mmap_write_ro.c
 create mode 100755 tests/generic/424
 create mode 100644 tests/generic/424.out

diff --git a/.gitignore b/.gitignore
index 1ed2a92..ee9329f 100644
--- a/.gitignore
+++ b/.gitignore
@@ -131,6 +131,7 @@
 /src/renameat2
 /src/t_rename_overwrite
 /src/t_mmap_dio
+/src/t_mmap_write_ro
 
 # dmapi/ binaries
 /dmapi/src/common/cmd/read_invis
diff --git a/src/Makefile b/src/Makefile
index a7f27f0..2604f52 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -12,7 +12,7 @@ TARGETS = dirstress fill fill2 getpagesize holes lstat64 \
 	godown resvtest writemod makeextents itrash rename \
 	multi_open_unlink dmiperf unwritten_sync genhashnames t_holes \
 	t_mmap_writev t_truncate_cmtime dirhash_collide t_rename_overwrite \
-	holetest t_truncate_self t_mmap_dio
+	holetest t_truncate_self t_mmap_dio t_mmap_write_ro
 
 LINUX_TARGETS = xfsctl bstat t_mtab getdevicesize preallo_rw_pattern_reader \
 	preallo_rw_pattern_writer ftrunc trunc fs_perms testx looptest \
diff --git a/src/t_mmap_write_ro.c b/src/t_mmap_write_ro.c
new file mode 100644
index 0000000..b6bf2a7
--- /dev/null
+++ b/src/t_mmap_write_ro.c
@@ -0,0 +1,76 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <fcntl.h>
+#include <unistd.h>
+#include <libgen.h>
+#include <errno.h>
+#include <sys/mman.h>
+
+void
+err_exit(char *op)
+{
+	fprintf(stderr, "%s: %s\n", op, strerror(errno));
+	exit(1);
+}
+
+int
+main(int argc, char **argv)
+{
+	int fd, pfd, ret;
+	char *buf;
+	volatile char foo;
+	int pagesize = getpagesize();
+
+	if (argc < 2) {
+		printf("Usage: %s <file> <pmem file>\n", basename(argv[0]));
+		exit(0);
+	}
+
+	fd = open(argv[1], O_RDONLY|O_DIRECT);
+	if (fd < 0)
+		err_exit("open");
+
+	pfd = open(argv[2], O_RDONLY);
+	if (pfd < 0)
+		err_exit("pmem open");
+
+	buf = mmap(NULL, pagesize, PROT_READ, MAP_SHARED, pfd, 0);
+	if (buf == MAP_FAILED)
+		err_exit("mmap");
+
+	/*
+	 * Read from the DAX mmap to populate the first page in the
+	 * address_space with a read-only mapping.
+	 */
+	foo = *buf;
+
+	/* quiet the compiler's "unused-but-set-variable" warning */
+	foo;
+
+	/*
+	 * Now write to the DAX mmap.  This *should* fail, but if the bug is
+	 * present in __get_user_pages_fast(), it will succeed.
+	 */
+	ret = read(fd, buf, pagesize);
+	if (ret != pagesize)
+		err_exit("read");
+
+	ret = msync(buf, pagesize, MS_SYNC);
+	if (ret != 0)
+		err_exit("msync");
+
+	ret = munmap(buf, pagesize);
+	if (ret < 0)
+		err_exit("munmap");
+
+	ret = close(fd);
+	if (ret < 0)
+		err_exit("clsoe fd");
+
+	ret = close(pfd);
+	if (ret < 0)
+		err_exit("close pfd");
+
+	exit(0);
+}
diff --git a/tests/generic/424 b/tests/generic/424
new file mode 100755
index 0000000..f73e08a
--- /dev/null
+++ b/tests/generic/424
@@ -0,0 +1,92 @@
+#! /bin/bash
+# FS QA Test 424
+#
+# This is a regression test for kernel commit
+#  ef947b2 x86, mm: fix gup_pte_range() vs DAX mappings
+# created by Jeffrey Moyer <jmoyer@redhat.com>
+#
+# This is reproducible only when testing on pmem device
+# which is configured in "memory mode", not in "raw mode".
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Red Hat.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -rf $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# Modify as appropriate.
+_supported_fs generic
+_supported_os Linux
+_require_scratch_dax
+_require_test_program "t_mmap_write_ro"
+_require_user
+
+# real QA test starts here
+
+_scratch_mkfs >>$seqres.full 2>&1
+_scratch_mount "-o dax"
+
+# remount TEST_DEV wo/ dax
+export MOUNT_OPTIONS=""
+export TEST_FS_MOUNT_OPTS=""
+_test_cycle_mount
+
+# prepare a 4k read-only DAX file, save its md5sum
+$XFS_IO_PROG -f -c "pwrite -S 0xFFFF 0 4096" \
+  $SCRATCH_MNT/readonlyfile >> $seqres.full 2>&1
+chmod 0644  $SCRATCH_MNT/readonlyfile
+md5_1="$(_md5_checksum $SCRATCH_MNT/readonlyfile)"
+
+# prepare another larger non-DAX file
+$XFS_IO_PROG -f -c "pwrite -S 0x0000 0 40960" \
+  $TEST_DIR/${seq}.largefile >> $seqres.full 2>&1
+# allow qa_user access
+chown $qa_user $TEST_DIR/${seq}.largefile
+
+# run test programme, read another larger file writing into
+# the read-only file with mmap, which should fail.
+_user_do "src/t_mmap_write_ro $TEST_DIR/${seq}.largefile \
+  $SCRATCH_MNT/readonlyfile"
+
+# read-only file should not get updated, md5sum again.
+md5_2="$(_md5_checksum $SCRATCH_MNT/readonlyfile)"
+
+[ "$md5_1" != "$md5_2" ] && echo "read only file changed"
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/424.out b/tests/generic/424.out
new file mode 100644
index 0000000..c836ec8
--- /dev/null
+++ b/tests/generic/424.out
@@ -0,0 +1,2 @@
+QA output created by 424
+read: Bad address
diff --git a/tests/generic/group b/tests/generic/group
index 52553fa..81db660 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -426,3 +426,4 @@
 421 auto quick encrypt dangerous
 422 auto quick
 423 auto quick
+424 auto quick
-- 
1.8.3.1


  parent reply	other threads:[~2017-04-12 14:46 UTC|newest]

Thread overview: 71+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-04-07  7:56 [PATCH 1/3] common: helper to get value from ndctl list by key Xiong Zhou
2017-04-07  7:56 ` [PATCH 2/3] DAX-DIO: skip DAX to non-DAX if unsupported Xiong Zhou
2017-04-12  3:30   ` Ross Zwisler
2017-04-07  7:56 ` [PATCH 3/3] DAX: mmap write readonly file Xiong Zhou
2017-04-07 17:16 ` [PATCH 1/3] common: helper to get value from ndctl list by key Ross Zwisler
2017-04-10  6:05   ` [PATCH v2 " Xiong Zhou
2017-04-10  6:05     ` [PATCH v2 2/3] DAX-DIO: skip DAX to non-DAX if unsupported Xiong Zhou
2017-04-11 11:44       ` Eryu Guan
2017-04-11 13:54         ` Jeff Moyer
2017-04-11 14:26         ` Xiong Zhou
2017-04-10  6:05     ` [PATCH v2 3/3] DAX: mmap write readonly file Xiong Zhou
2017-04-11 11:46       ` Eryu Guan
2017-04-11 13:56         ` Jeff Moyer
2017-04-11 18:52           ` Ross Zwisler
2017-04-11 22:45             ` Ross Zwisler
2017-04-12  2:52               ` Xiong Zhou
2017-04-12  4:03       ` Ross Zwisler
2017-04-12  6:26         ` Xiong Zhou
2017-04-12 14:46           ` [PATCH v3 0/4] split DAX mmap DIO cases Xiong Zhou
2017-04-12 14:46             ` [PATCH v3 1/4] DAX-DIO: make dax_to_non_dax dio test solo Xiong Zhou
2017-04-12 14:46             ` [PATCH v3 2/4] generic: test mmap io fom DAX to non-DAX Xiong Zhou
2017-04-13  4:11               ` Xiong Zhou
2017-04-13 13:36                 ` Dan Williams
2017-04-14 10:01                   ` Xiong Zhou
2017-04-14 14:49                     ` Dan Williams
2017-04-14 15:22                       ` Ross Zwisler
2017-04-14 15:33                         ` Dan Williams
2017-04-14 15:51                           ` Ross Zwisler
2017-04-12 14:46             ` [PATCH v3 3/4] xfs: test per-inode DAX flag " Xiong Zhou
2017-04-12 14:46             ` Xiong Zhou [this message]
2017-04-17  7:14             ` [PATCH v4 0/4] split DAX mmap DIO cases Xiong Zhou
2017-04-17  7:14               ` [PATCH v4 1/4] DAX-DIO: make dax_to_non_dax dio test solo Xiong Zhou
2017-04-18 16:31                 ` Ross Zwisler
2017-04-17  7:14               ` [PATCH v4 2/4] generic: test mmap io fom DAX to non-DAX Xiong Zhou
2017-04-17 14:14                 ` Dan Williams
2017-04-17 22:54                   ` Dan Williams
2017-04-17 23:39                     ` Ross Zwisler
2017-04-17 23:47                       ` Dan Williams
2017-04-19  8:40                   ` Xiong Zhou
2017-04-19 15:53                     ` Dan Williams
2017-04-18 10:12                 ` Christoph Hellwig
2017-04-18 14:49                   ` Xiong Zhou
2017-07-28 14:55                   ` Jeff Moyer
2017-04-18 16:32                 ` Ross Zwisler
2017-04-17  7:14               ` [PATCH v4 3/4] xfs: test per-inode DAX flag " Xiong Zhou
2017-04-18 16:36                 ` Ross Zwisler
2017-04-17  7:14               ` [PATCH v4 4/4] generic: mmap write readonly DAX file Xiong Zhou
2017-04-18 17:05                 ` Ross Zwisler
2017-04-19  2:54                   ` Xiong Zhou
2017-04-24 16:34                 ` Ross Zwisler
2017-09-25  8:40               ` [PATCH v5 0/3] fix dax to nondax dio fake failures Xiong Zhou
2017-09-25  8:40                 ` [PATCH v5 1/3] generic: mmap write readonly DAX file Xiong Zhou
2017-09-27  9:57                   ` Eryu Guan
2017-09-25  8:40                 ` [PATCH v5 2/3] generic/413: skip dax to nondax dio test if needed Xiong Zhou
2017-09-27  9:50                   ` Eryu Guan
2017-09-27 15:01                     ` Jeff Moyer
2017-09-25  8:40                 ` [PATCH v5 3/3] xfs/260: remove per-inode DAX flag test Xiong Zhou
2017-09-25 16:59                   ` Ross Zwisler
2017-09-26  0:51                     ` Xiong Zhou
2017-09-28  7:41                 ` [PATCH v6 0/4] fix dax to nondax dio fake failures Xiong Zhou
2017-09-28  7:41                   ` [PATCH v6 1/4] tests: add new group dax Xiong Zhou
2017-09-28  7:41                   ` [PATCH v6 2/4] gitignore: sort src/ binaries name Xiong Zhou
2017-09-28 11:10                     ` Dave Chinner
2017-09-28 12:28                       ` Xiong Zhou
2017-09-28 21:43                         ` Dave Chinner
2017-09-28  7:41                   ` [PATCH v6 3/4] generic: mmap write readonly DAX file Xiong Zhou
2017-09-28  7:41                   ` [PATCH v6 4/4] generic/413: skip dax to nondax dio test if needed Xiong Zhou
2017-09-29  2:16                   ` [PATCH v7] " Xiong Zhou
2017-09-29 16:24                     ` Ross Zwisler
2017-09-30  2:30                       ` Xiong Zhou
2017-04-11 11:40     ` [PATCH v2 1/3] common: helper to get value from ndctl list by key Eryu Guan

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1492008380-29164-5-git-send-email-xzhou@redhat.com \
    --to=xzhou@redhat.com \
    --cc=dan.j.williams@intel.com \
    --cc=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    --cc=jmoyer@redhat.com \
    --cc=ross.zwisler@linux.intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.